=== modified file 'plugin/information_schema_dictionary/key_column_usage.cc'
--- plugin/information_schema_dictionary/key_column_usage.cc	2010-07-11 15:57:03 +0000
+++ plugin/information_schema_dictionary/key_column_usage.cc	2010-10-06 00:12:36 +0000
@@ -41,7 +41,9 @@
   InformationSchema::Generator(arg),
   generator(getSession()),
   index_iterator(0),
-  index_part_iterator(0)
+  index_part_iterator(0),
+  fk_constraint_iterator(0),
+  fk_constraint_column_name_iterator(0)
 {
   while (not (table_message= generator))
   { };
@@ -84,7 +86,7 @@
         push(table_message->field(fieldnr).name());
 
         /* ORDINAL_POSITION */
-        push(static_cast<int64_t>(index_part_iterator));
+        push(static_cast<int64_t>((index_part_iterator +1)));
 
         if (index_part_iterator == index.index_part_size() -1)
         {
@@ -100,9 +102,56 @@
       }
     }
 
+    if (fk_constraint_iterator != table_message->fk_constraint_size())
+    {
+      drizzled::message::Table::ForeignKeyConstraint foreign_key= table_message->fk_constraint(fk_constraint_iterator);
+
+      {
+        /* Constraints live in the same catalog.schema as the table they refer too. */
+        /* CONSTRAINT_CATALOG */
+        push(table_message->catalog());
+
+        /* CONSTRAINT_SCHEMA */
+        push(table_message->schema());
+
+        /* CONSTRAINT_NAME */
+        push(foreign_key.name());
+
+        /* TABLE_CATALOG */
+        push(table_message->catalog());
+
+        /* TABLE_SCHEMA */
+        push(table_message->schema());
+
+        /* TABLE_NAME */
+        push(table_message->name());
+
+        /* COLUMN_NAME */
+        push(foreign_key.column_names(fk_constraint_column_name_iterator));
+
+        /* ORDINAL_POSITION */
+        push(static_cast<int64_t>((fk_constraint_column_name_iterator + 1)));
+
+        if (fk_constraint_column_name_iterator == foreign_key.column_names_size() -1)
+        {
+          fk_constraint_iterator++;
+          fk_constraint_column_name_iterator= 0;
+        }
+        else
+        {
+          fk_constraint_column_name_iterator++;
+        }
+
+        return true;
+      }
+    }
+
     index_iterator= 0;
     index_part_iterator= 0;
 
+    fk_constraint_iterator= 0;
+    fk_constraint_column_name_iterator= 0;
+
   } while ((table_message= generator));
 
   return false;

=== modified file 'plugin/information_schema_dictionary/key_column_usage.h'
--- plugin/information_schema_dictionary/key_column_usage.h	2010-07-09 21:52:18 +0000
+++ plugin/information_schema_dictionary/key_column_usage.h	2010-10-06 00:12:36 +0000
@@ -34,6 +34,9 @@
     int32_t index_iterator;
     int32_t index_part_iterator;
 
+    int32_t fk_constraint_iterator;
+    int32_t fk_constraint_column_name_iterator;
+
   public:
     Generator(drizzled::Field **arg);
 

=== modified file 'plugin/information_schema_dictionary/tests/r/key_column_usage.result'
--- plugin/information_schema_dictionary/tests/r/key_column_usage.result	2010-07-09 21:52:18 +0000
+++ plugin/information_schema_dictionary/tests/r/key_column_usage.result	2010-10-06 00:12:36 +0000
@@ -336,40 +336,40 @@
 ) ;
 select * from information_schema.key_column_usage WHERE table_schema="everything" ORDER BY TABLE_SCHEMA, TABLE_NAME, COLUMN_NAME;
 CONSTRAINT_CATALOG	CONSTRAINT_SCHEMA	CONSTRAINT_NAME	TABLE_CATALOG	TABLE_SCHEMA	TABLE_NAME	COLUMN_NAME	ORDINAL_POSITION
-	everything	PRIMARY		everything	branch	branch_id	0
-	everything	PRIMARY		everything	container	container_id	0
-	everything	PRIMARY		everything	document	document_id	0
-	everything	PRIMARY		everything	genstats_attributes	genstats_attributes_id	0
-	everything	PRIMARY		everything	htmlcode	htmlcode_id	0
-	everything	PRIMARY		everything	htmlpage	htmlpage_id	0
-	everything	PRIMARY		everything	image	image_id	0
-	everything	PRIMARY		everything	javascript	javascript_id	0
-	everything	PRIMARY		everything	knowledge_item	knowledge_item_id	0
-	everything	PRIMARY		everything	links	from_node	0
-	everything	PRIMARY		everything	links	linktype	2
-	everything	PRIMARY		everything	links	to_node	1
-	everything	PRIMARY		everything	mail	mail_id	0
-	everything	PRIMARY		everything	node	node_id	0
-	everything	PRIMARY		everything	nodegroup	nodegroup_id	0
-	everything	PRIMARY		everything	nodegroup	rank	1
-	everything	PRIMARY		everything	nodelet	nodelet_id	0
-	everything	PRIMARY		everything	nodemethod	nodemethod_id	0
-	everything	PRIMARY		everything	nodetype	nodetype_id	0
-	everything	PRIMARY		everything	project	project_id	0
-	everything	PRIMARY		everything	project_document	project_document_id	0
-	everything	PRIMARY		everything	question	question_id	0
-	everything	PRIMARY		everything	question	rank	1
-	everything	PRIMARY		everything	redirects	redirects_id	0
-	everything	PRIMARY		everything	releases	releases_id	0
-	everything	PRIMARY		everything	revision	inside_workspace	1
-	everything	PRIMARY		everything	revision	node_id	0
-	everything	PRIMARY		everything	revision	revision_id	2
-	everything	PRIMARY		everything	setting	setting_id	0
-	everything	PRIMARY		everything	symlink	symlink_id	0
-	everything	PRIMARY		everything	themesetting	themesetting_id	0
-	everything	PRIMARY		everything	typeversion	typeversion_id	0
-	everything	PRIMARY		everything	user	user_id	0
-	everything	PRIMARY		everything	version	version_id	0
-	everything	PRIMARY		everything	weblog	entry_id	0
-	everything	PRIMARY		everything	workspace	workspace_id	0
+	everything	PRIMARY		everything	branch	branch_id	1
+	everything	PRIMARY		everything	container	container_id	1
+	everything	PRIMARY		everything	document	document_id	1
+	everything	PRIMARY		everything	genstats_attributes	genstats_attributes_id	1
+	everything	PRIMARY		everything	htmlcode	htmlcode_id	1
+	everything	PRIMARY		everything	htmlpage	htmlpage_id	1
+	everything	PRIMARY		everything	image	image_id	1
+	everything	PRIMARY		everything	javascript	javascript_id	1
+	everything	PRIMARY		everything	knowledge_item	knowledge_item_id	1
+	everything	PRIMARY		everything	links	from_node	1
+	everything	PRIMARY		everything	links	linktype	3
+	everything	PRIMARY		everything	links	to_node	2
+	everything	PRIMARY		everything	mail	mail_id	1
+	everything	PRIMARY		everything	node	node_id	1
+	everything	PRIMARY		everything	nodegroup	nodegroup_id	1
+	everything	PRIMARY		everything	nodegroup	rank	2
+	everything	PRIMARY		everything	nodelet	nodelet_id	1
+	everything	PRIMARY		everything	nodemethod	nodemethod_id	1
+	everything	PRIMARY		everything	nodetype	nodetype_id	1
+	everything	PRIMARY		everything	project	project_id	1
+	everything	PRIMARY		everything	project_document	project_document_id	1
+	everything	PRIMARY		everything	question	question_id	1
+	everything	PRIMARY		everything	question	rank	2
+	everything	PRIMARY		everything	redirects	redirects_id	1
+	everything	PRIMARY		everything	releases	releases_id	1
+	everything	PRIMARY		everything	revision	inside_workspace	2
+	everything	PRIMARY		everything	revision	node_id	1
+	everything	PRIMARY		everything	revision	revision_id	3
+	everything	PRIMARY		everything	setting	setting_id	1
+	everything	PRIMARY		everything	symlink	symlink_id	1
+	everything	PRIMARY		everything	themesetting	themesetting_id	1
+	everything	PRIMARY		everything	typeversion	typeversion_id	1
+	everything	PRIMARY		everything	user	user_id	1
+	everything	PRIMARY		everything	version	version_id	1
+	everything	PRIMARY		everything	weblog	entry_id	1
+	everything	PRIMARY		everything	workspace	workspace_id	1
 drop schema everything;

=== modified file 'tests/include.am'
--- tests/include.am	2010-10-02 21:15:42 +0000
+++ tests/include.am	2010-10-07 21:43:26 +0000
@@ -22,8 +22,8 @@
 GENSCRIPTS =		tests/dtr tests/mtr tests/test-run
 PRESCRIPTS =		tests/test-run.pl tests/stress-test.pl
 PLUGIN_TESTS =		$(pandora_plugin_test_list)
-NORMAL_TESTS =		main,jp,tamil,$(PLUGIN_TESTS)
-ALL_TESTS =		main,big,jp,tamil,$(PLUGIN_TESTS)
+NORMAL_TESTS =		main,jp,tamil,regression,$(PLUGIN_TESTS)
+ALL_TESTS =		main,big,jp,tamil,regression,$(PLUGIN_TESTS)
 noinst_SCRIPTS =	$(GENSCRIPTS) $(PRESCRIPTS)
 CLEANFILES += 		$(GENSCRIPTS) tests/mtr
 

=== added directory 'tests/suite/regression'
=== added directory 'tests/suite/regression/r'
=== added file 'tests/suite/regression/r/654219.result'
--- tests/suite/regression/r/654219.result	1970-01-01 00:00:00 +0000
+++ tests/suite/regression/r/654219.result	2010-10-06 00:12:36 +0000
@@ -0,0 +1,63 @@
+CREATE TABLE `prim_key` (
+`id` INT NOT NULL,
+`val` VARCHAR(20) COLLATE utf8_general_ci DEFAULT NULL,
+PRIMARY KEY (`id`)
+);
+CREATE TABLE `fore_key0` (
+`id` INT NOT NULL,
+`id_ref0` INT DEFAULT NULL,
+PRIMARY KEY (`id`),
+KEY `id_ref0` (`id_ref0`),
+CONSTRAINT `fore_key0_ibfk_1` FOREIGN KEY (`id_ref0`) REFERENCES
+`prim_key` (`id`)
+);
+CREATE TABLE `fore_key1` (
+`id` INT NOT NULL,
+`id_ref1` INT DEFAULT NULL,
+PRIMARY KEY (`id`),
+KEY `id_ref1` (`id_ref1`),
+CONSTRAINT `fore_key1_ibfk_1` FOREIGN KEY (`id_ref1`) REFERENCES
+`prim_key` (`id`) ON UPDATE CASCADE
+);
+SELECT CONSTRAINT_NAME,TABLE_NAME,COLUMN_NAME,ORDINAL_POSITION FROM INFORMATION_SCHEMA.KEY_COLUMN_USAGE;
+CONSTRAINT_NAME	TABLE_NAME	COLUMN_NAME	ORDINAL_POSITION
+PRIMARY	prim_key	id	1
+PRIMARY	fore_key1	id	1
+fore_key1_ibfk_1	fore_key1	id_ref1	1
+PRIMARY	fore_key0	id	1
+fore_key0_ibfk_1	fore_key0	id_ref0	1
+DROP TABLE fore_key1;
+DROP TABLE fore_key0;
+DROP TABLE prim_key;
+CREATE TABLE t1
+(
+s1 INT,
+s2 INT,
+s3 INT,
+PRIMARY KEY(s3)
+);
+CREATE TABLE t3
+(
+s1 INT,
+s2 INT,
+s3 INT,
+KEY(s1),
+CONSTRAINT CO FOREIGN KEY (s2)
+REFERENCES t1(s3)
+);
+SELECT CONSTRAINT_NAME,TABLE_NAME,COLUMN_NAME,ORDINAL_POSITION FROM INFORMATION_SCHEMA.KEY_COLUMN_USAGE;
+CONSTRAINT_NAME	TABLE_NAME	COLUMN_NAME	ORDINAL_POSITION
+CO	t3	s2	1
+PRIMARY	t1	s3	1
+DROP TABLE t3;
+DROP TABLE t1;
+CREATE TABLE t1 (c1 INT NOT NULL, c2 INT NOT NULL, c3 CHAR(5), c4 INT, c5 INT, constraint pk_t1 PRIMARY KEY (c5,c4));
+CREATE TABLE T2 (tc1 INT NOT NULL, c1 INT NOT NULL, c2 INT NOT NULL, c5 CHAR(5), constraint fk_t2 FOREIGN KEY (c1,c2) REFERENCES t1 (c5,c4));
+SELECT CONSTRAINT_NAME, TABLE_NAME, COLUMN_NAME, ORDINAL_POSITION FROM INFORMATION_SCHEMA.KEY_COLUMN_USAGE WHERE TABLE_NAME IN ('t1', 't2');
+CONSTRAINT_NAME	TABLE_NAME	COLUMN_NAME	ORDINAL_POSITION
+PRIMARY	t1	c5	1
+PRIMARY	t1	c4	2
+fk_t2	t2	c1	1
+fk_t2	t2	c2	2
+DROP TABLE t2;
+DROP TABLE t1;

=== added directory 'tests/suite/regression/t'
=== added file 'tests/suite/regression/t/654219.test'
--- tests/suite/regression/t/654219.test	1970-01-01 00:00:00 +0000
+++ tests/suite/regression/t/654219.test	2010-10-06 00:12:36 +0000
@@ -0,0 +1,64 @@
+CREATE TABLE `prim_key` (
+  `id` INT NOT NULL,
+  `val` VARCHAR(20) COLLATE utf8_general_ci DEFAULT NULL,
+  PRIMARY KEY (`id`)
+);
+
+CREATE TABLE `fore_key0` (
+  `id` INT NOT NULL,
+  `id_ref0` INT DEFAULT NULL,
+  PRIMARY KEY (`id`),
+  KEY `id_ref0` (`id_ref0`),
+  CONSTRAINT `fore_key0_ibfk_1` FOREIGN KEY (`id_ref0`) REFERENCES
+  `prim_key` (`id`)
+);
+
+CREATE TABLE `fore_key1` (
+  `id` INT NOT NULL,
+  `id_ref1` INT DEFAULT NULL,
+  PRIMARY KEY (`id`),
+  KEY `id_ref1` (`id_ref1`),
+  CONSTRAINT `fore_key1_ibfk_1` FOREIGN KEY (`id_ref1`) REFERENCES
+  `prim_key` (`id`) ON UPDATE CASCADE
+);
+
+SELECT CONSTRAINT_NAME,TABLE_NAME,COLUMN_NAME,ORDINAL_POSITION FROM INFORMATION_SCHEMA.KEY_COLUMN_USAGE;
+
+DROP TABLE fore_key1;
+DROP TABLE fore_key0;
+DROP TABLE prim_key;
+
+# Taken from MySQL example
+CREATE TABLE t1
+(
+  s1 INT,
+  s2 INT,
+  s3 INT,
+  PRIMARY KEY(s3)
+);
+
+CREATE TABLE t3
+(
+  s1 INT,
+  s2 INT,
+  s3 INT,
+  KEY(s1),
+  CONSTRAINT CO FOREIGN KEY (s2)
+  REFERENCES t1(s3)
+);
+
+SELECT CONSTRAINT_NAME,TABLE_NAME,COLUMN_NAME,ORDINAL_POSITION FROM INFORMATION_SCHEMA.KEY_COLUMN_USAGE;
+
+DROP TABLE t3;
+DROP TABLE t1;
+
+# Taken from SQL Server example
+CREATE TABLE t1 (c1 INT NOT NULL, c2 INT NOT NULL, c3 CHAR(5), c4 INT, c5 INT, constraint pk_t1 PRIMARY KEY (c5,c4));
+
+CREATE TABLE T2 (tc1 INT NOT NULL, c1 INT NOT NULL, c2 INT NOT NULL, c5 CHAR(5), constraint fk_t2 FOREIGN KEY (c1,c2) REFERENCES t1 (c5,c4));
+
+SELECT CONSTRAINT_NAME, TABLE_NAME, COLUMN_NAME, ORDINAL_POSITION FROM INFORMATION_SCHEMA.KEY_COLUMN_USAGE WHERE TABLE_NAME IN ('t1', 't2');
+
+DROP TABLE t2;
+DROP TABLE t1;
+  

